#!/usr/bin/env python
# encoding: utf-8
"""
convert.py: INFO/CS/4302 FT 2012 - Homework 7 - Task 1

Created by ??? on ???.
"""

import os, sys, codecs
from rdflib import ConjunctiveGraph, URIRef, Literal, Namespace, RDF

DCTERMS = Namespace('http://purl.org/dc/terms/')
# TODO: define further namespaces

class MovieRDFDatabase(object):
    
    def __init__(self, movies_csv, actors_csv, mapping_csv):
        print "Initialize graph, set namespace mappings..."
        self.graph = ConjunctiveGraph()
        self.graph.bind('dcterms', DCTERMS)
        # TODO: bind further namespaces
        print "Loading data into memory...."
        movie_data = self.read_from_csv(movies_csv)
        actor_data = self.read_from_csv(actors_csv)
        mapping_data = self.read_from_csv(mapping_csv)
        for movie in movie_data: self.add_movie(movie)
        for actor in actor_data: self.add_actor(actor)
        for mapping in mapping_data: self.link_movie_actor(mapping)
        print "Total number of loaded triples: %d" % len(self.graph)
        # TODO serialize graph into at least two files
        
    def add_movie(self, movie):
        """Add movie data to the graph"""
        pass
        # TODO: implement method
        
    def add_actor(self, actor):
        """Add actor data to the graph"""
        pass
        # TODO: implement method
        
    def link_movie_actor(self, mapping):
        """Add a link between a movie and an actor"""
        pass
        # TODO: implement method
    
    def read_from_csv(self, csv_file):
        """Reads CSV entries into a list containing a set of dictionaries.
        CSV header row entries are taken as dictionary keys"""
        data = []
        with codecs.open(csv_file, 'r', encoding='utf-8') as csvfile:
            header = None
            for i, line in enumerate(csvfile):
                line_split = [x.strip() for x in line.split("|")]
                line_data = [x for x in line_split if len(x) > 0]
                if i == 0:
                    header = line_data
                else:
                    entry = {}
                    for i,datum in enumerate(line_data):
                        entry[header[i]] = datum
                    data.append(entry)
        print "Loaded %d entries from %s" % (len(data), csv_file)
        return data    

def main(argv=None):
    if not argv:
        argv = sys.argv
    if argv[1] in ('help', '--help', 'h', '-h') or len(argv) < 1:
        print("Usage: ./convert.py data/movies.csv data/actors.csv data/movie_actors.csv")
    else:
        movies_csv = argv[1]
        actors_csv = argv[2]
        mapping_csv = argv[3]
    db = MovieRDFDatabase(movies_csv, actors_csv, mapping_csv)

if __name__ == '__main__':
	main()

